<?php

//
// 2005/2006 Bernhard Vogl (http://dativ.at)
//
// This software is intended as an expansion of Aldo Hoeben's "qtparser" package.
// See: http://www.fieldofview.nl/spv
//
//
// Usage:
// http://YOUR_URL/convert2.php?file=NAME_OF_HTMFILE[&format=format][&pos=QTVR_TRACK_POSITION]
// pos: defaults to 1 if not specified
// format: defaults to qtvr if not specified
//         valid formats:
//         QTVR: "qtvr" (QTVR to QTVR format conversion to circumvent 'click me' message...)
//         Spi-V: "spiv"
//         DevalVR: "devr"
//         PangeaVR: "pangea"
//         Flash: "flash"

//Check for js-helper and create, if not found
if (!file_exists("writecontrol.js")) {
	$filepointer = fopen("writecontrol.js", "wb");
	fwrite($filepointer, "document.write(theCtrl);");
	fclose($filepointer);
};	

// Get input parameters
$conv_format = (array_key_exists("format", $_GET)) ? $_GET["format"] : "qtvr";
$file = (array_key_exists("file", $_GET)) ? $_GET["file"] : "";
$want_pos = (array_key_exists("pos", $_GET)) ? $_GET["pos"] : 1;

if (!file_exists($file)) {
	exit ("Convert: No input file, file not found or illegal method.");
};



// Read File in Memory
$filePointer=fOpen($file,"r");
$fileContents=fRead($filePointer, fileSize($file));

// Call the Parser
$htm_out=dig_html ("", $fileContents, "", "", "", $want_pos, 1);

// This modification only needed for modified qtparser
$file_wo_ext = array_shift(explode('.', basename($htm_out[2], 2)));
$panofile = $file_wo_ext.".mov";


// Generate modified HTML Page

// "left" part
echo $htm_out[0];
if ($conv_format == "spiv") {
?>
<script type="text/javascript"><!--
theCtrl='';
theCtrl+='<object width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> classid="clsid:166B1BCA-3F9C-11CF-8075-444553540000"';
theCtrl+=' codebase="http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0">';
theCtrl+='  <param name=src value="SPi-V.dcr">';
theCtrl+='  <param name=swURL value="qtparser.php?mov=<? echo $panofile ?>">';
theCtrl+='  <param name=swStretchStyle value=stage>';
theCtrl+='  <param name=bgColor value=#000000>';
theCtrl+='  <embed width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> type="application/x-director" pluginspage="http://www.macromedia.com/shockwave/download/"';
theCtrl+='  src="SPi-V.dcr" swURL="qtparser.php?mov=<? echo $panofile ?>" swStretchStyle=stage progress=TRUE logo=TRUE bgColor=#000000>';
theCtrl+='  </embed>';
theCtrl+='</object> ';
//--></script>
<script type="text/javascript"
  src="writecontrol.js">
</script>
<noscript>
<object width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> classid="clsid:166B1BCA-3F9C-11CF-8075-444553540000"
 codebase="http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0">
  <param name=src value="SPi-V.dcr">
  <param name=swURL value="qtparser.php?mov=<? echo $panofile ?>">
  <param name=swStretchStyle value=stage>
  <param name=bgColor value=#000000>
  <embed width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> type="application/x-director" pluginspage="http://www.macromedia.com/shockwave/download/"
  src="SPi-V.dcr" swURL="qtparser.php?mov=<? echo $panofile ?>" swStretchStyle=stage progress=TRUE logo=TRUE bgColor=#000000>
  </embed>
</object> 
</noscript>
<?
  } elseif ($conv_format == "qtvr") {
?>
<script type="text/javascript"><!--
theCtrl='';
theCtrl+='<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" codebase="http://www.apple.com/qtactivex/qtplugin.cab" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">';
theCtrl+='  <param name="SRC" value="<? echo $panofile ?>">';
theCtrl+='  <param name="SCALE" value="tofit">';
theCtrl+='  <param name="CONTROLLER" value="true"> ';
theCtrl+='  <embed src="<? echo $panofile ?> " controller="true" scale="tofit" pluginspage="http://www.apple.com/quicktime/download/" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">';
theCtrl+='</object>';
//--></script>
<script type="text/javascript"
  src="writecontrol.js">
</script>
<noscript>
<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" codebase="http://www.apple.com/qtactivex/qtplugin.cab" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">
  <param name="SRC" value="<? echo $panofile ?>">
  <param name="SCALE" value="tofit">
  <param name="CONTROLLER" value="true"> 
  <embed src="<? echo $panofile ?> " controller="true" scale="tofit" pluginspage="http://www.apple.com/quicktime/download/" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">
</object>
</noscript>
<?
  } elseif ($conv_format == "flash") {
?>
<script type="text/javascript"><!--
theCtrl='';
theCtrl+='<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">';
theCtrl+='  <param name="MOVIE" value="<? echo $file_wo_ext ?>.swf">';
theCtrl+='  <param name="SCALE" value="tofit">';
theCtrl+='  <embed src="<? echo $file_wo_ext ?>.swf " type="application/x-shockwave-flash" scale="tofit" pluginspage="http://www.macromedia.com/go/getflashplayer" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">';
theCtrl+='</object>';
//--></script>
<script type="text/javascript"
  src="writecontrol.js">
</script>
<noscript>
<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">
  <param name="SRC" value="<? echo $panofile ?>.swf">
  <param name="SCALE" value="tofit">
  <embed src="<? echo $file_wo_ext ?>.swf" scale="tofit" pluginspage="http://www.macromedia.com/go/getflashplayer" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> border="0">
</object>
</noscript>
<?
  } elseif ($conv_format == "devr") {
?>
<script type="text/javascript"><!--
theCtrl='';
theCtrl+='<OBJECT codeBase="http://www.devalvr.com/instalacion/plugin/devalocx.cab#version=0,2,7,1" classid=clsid:5D2CF9D0-113A-476B-986F-288B54571614 style="WIDTH: <? echo $htm_out[3] ?>; HEIGHT: <? echo $htm_out[4] ?>" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> >';
theCtrl+='<PARAM NAME="filter" VALUE="1">';
theCtrl+='<PARAM NAME="src" VALUE="<? echo $panofile ?>">';
theCtrl+='<EMBED PLUGINSPAGE="http://www.devalvr.com/instalacion/plugin/install.html"';
theCtrl+='TYPE="application/x-DevalVRX" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> filter="1" src="<? echo $panofile ?>"></EMBED>';
theCtrl+='</OBJECT>';
//--></script>
<script type="text/javascript"
  src="writecontrol.js">
</script>
<noscript>
<OBJECT codeBase="http://www.devalvr.com/instalacion/plugin/devalocx.cab#version=0,2,7,1" classid=clsid:5D2CF9D0-113A-476B-986F-288B54571614 style="WIDTH: <? echo $htm_out[3] ?>; HEIGHT: <? echo $htm_out[4] ?>" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> >
<PARAM NAME="filter" VALUE="1">
<PARAM NAME="src" VALUE="<? echo $panofile ?>">
<EMBED PLUGINSPAGE="http://www.devalvr.com/instalacion/plugin/install.html"
TYPE="application/x-DevalVRX" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> filter="1" src="<? echo $panofile ?>"></EMBED>
</OBJECT>
</noscript>
<?
  } elseif ($conv_format == "pangea") {
?>
<script type="text/javascript"><!--
theCtrl='';
theCtrl+='<embed PLUGINSPAGE = "http://www.pangeasoft.net/pano/plugin/downloads.html" src="<? echo $panofile ?>" type="graphics/pangeavr2" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> >';
//--></script>
<script type="text/javascript"
  src="writecontrol.js">
</script>
<noscript>
<embed PLUGINSPAGE = "http://www.pangeasoft.net/pano/plugin/downloads.html" src="<? echo $panofile ?>" type="graphics/pangeavr2" width=<? echo $htm_out[3] ?> height=<? echo $htm_out[4] ?> >
</noscript>
<?
  } else {
    exit ("Sorry, Target Panorama Format not understood!");
};
// "right" part
echo $htm_out[1];
exit;

// This function will strip the <object> tag from the input page
// and extract movie file and plugin dimensions
// Parameters (in/out): (already searched part, part to search, (out:) movie file name,
// (out:) width, (out:) heigth, (in:) position of object), (in/out:) parsed positions)
function dig_html ($processed, $infile, $mov, $w, $h, $want_pos, $pos) {
  if ($infile=="") {
    echo "Convert: Parsing error: no matching object found!</br>";
    echo "Check input file and parameters!";
    exit;
  }
  $pieces=explode("<",$infile,2);
  $left=$pieces[0];
  $found_object=false;
  // Code for checking correct position begin
  if ((strpos($pieces[1], "object")!==false) and (strpos($pieces[1], "object") < 5)){
    $found_object=true;
  }
  if ($pos < $want_pos) {
    $pos++;
    $found_object=false;
    $pieces=explode("/object",$infile,2);
  }
  // Code for checking correct position end
  if ($found_object==true) {
    $mov=getTagval (stristr ($pieces[1], "src"), "value");
    $w=getTagval ($pieces[1], "width");
    $h=getTagval ($pieces[1], "height");
    $left=$processed.$pieces[0];
    $right=substr (stristr(stristr($pieces[1], "/object"),">"),1);
  } else {
    list ($left,$right)=explode(">", $pieces[1],2);
    $left=$pieces[0]."<".$left.">";
    list ($left, $right, $mov, $w, $h, $want_pos, $pos)=dig_html ($processed.$left, $right, $mov, $w, $h, $want_pos, $pos);
  }
  return array ($left, $right, $mov, $w, $h, $want_pos, $pos);
}

// Helper for extracting tag values
// Parameters(in): code fragment to search, tag name
//          (out): tag value
function getTagval ($instring, $tag) {
  $pattern='[=|"| ]';
  $otag=preg_split ($pattern, stristr(stristr ($instring, $tag), "="), -1, PREG_SPLIT_NO_EMPTY);
  foreach ($otag as $element) {
    if ( !preg_match($pattern, $element) ) {
      $w=$element;
      break;
    }
  }
  return $element;
}

?>